/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://www.nongnu.org/gtkcooker
 * Public domain.
 */

#ifndef _WIDGET_DRIVER_H_
#define _WIDGET_DRIVER_H_

struct widget_driver;

#include "widget.h"
#include "gtk_widget.h"

typedef struct widget_driver {
  char *name;
  int (*first_pass_translation)(widget, widget_element);
  int (*second_pass_translation)(widget, widget_element);
  int (*populate_properties)(gtk_widget);
  int (*generate_struct)(gtk_widget);
  int (*generate_signal_handlers)(widget, gtk_widget);
  int (*generate_variable_declaration)(gtk_widget);
  int (*generate_variable_instanciation)(gtk_widget);
  int (*generate_pack)(gtk_widget);
  int (*generate_post_pack)(gtk_widget);
  int (*generate_signals)(gtk_widget);
} widget_driver;

#define NB_WIDGETS 15
extern widget_driver *widget_drivers[NB_WIDGETS];

widget_driver *find_driver(char *);

#endif /* _WIDGET_DRIVER_H_ */
