/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://www.nongnu.org/gtkcooker
 * Public domain.
 */

#include <string.h>

#include "widget.h"
#include "generate.h"
#include "files.h"
#include "keywords.h"
#include "code.h"
#include "globals.h"

#if 0
/* -1 error, 0 ok */
static int first_pass_translation(widget w, widget_element e)
{
  return 0;
}
#endif

#if 0
/* -1 error, 0 ok */
static int second_pass_translation(widget w, widget_element e)
{
  return 0;
}
#endif

/* -1 error, 0 ok */
static int populate_properties(gtk_widget gw)
{
  int has_to_populate;
  gtk_widget sw;
  widget_driver *sd;

  sw = (gtk_widget)RESIZER_FIRST_CHILD(gw);
  sd = WIDGET_DRIVER(sw);
  has_to_populate = 0;

  POPULATE_PROPERTIES

  if (has_to_populate)
    if (sd->populate_properties)
      if (sd->populate_properties(sw) == -1)
        return -1;

  sw = (gtk_widget)RESIZER_SECOND_CHILD(gw);
  sd = WIDGET_DRIVER(sw);
  has_to_populate = 0;

  POPULATE_PROPERTIES

  if (has_to_populate)
    if (sd->populate_properties)
      if (sd->populate_properties(sw) == -1)
        return -1;

  return 0;
}

/* -1 error, 0 ok */
static int generate_struct(gtk_widget gw)
{
  if (!IS_GLOBAL(gw)) return 0;

  if (hide_gtk)
    PUT_H("  /* GtkWidget* */ void *");
  else
    PUT_H("  GtkWidget *");
  PUT_H(get_identifier(WIDGET_NAME(gw)));
  PUT_H(";\n");

  return 0;
}

#if 0
/* -1 error, 0 ok */
static int generate_signal_handlers(widget w, gtk_widget gw)
{
  return 0;
}
#endif

/* -1 error, 0 ok */
static int generate_variable_declaration(gtk_widget gw)
{
  if (IS_GLOBAL(gw)) return 0;

  PUT_C("  GtkWidget *");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C(";\n");

  return 0;
}

/* -1 error, 0 ok */
static int generate_variable_instanciation(gtk_widget gw)
{
  PUT_C("  ");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C(" = gtk_");
  if (RESIZER_TYPE(gw) == RESIZER_HORIZONTAL)
    PUT_C("h");
  else
    PUT_C("v");
  PUT_C("paned_new();\n");

  GENERATE_FOREGROUND_AND_BACKGROUND

  return 0;
}

/* -1 error, 0 ok */
static int generate_pack(gtk_widget gw)
{
  gtk_widget sw;

  sw = RESIZER_FIRST_CHILD(gw);
  PUT_C("  gtk_paned_pack1(GTK_PANED(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("), ");
  if (hide_gtk)
    PUT_C("(GtkWidget *)");
  if (IS_GLOBAL(sw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(sw)));
  PUT_C(", TRUE, TRUE);\n");

  sw = RESIZER_SECOND_CHILD(gw);
  PUT_C("  gtk_paned_pack2(GTK_PANED(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("), ");
  if (hide_gtk)
    PUT_C("(GtkWidget *)");
  if (IS_GLOBAL(sw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(sw)));
  PUT_C(", TRUE, TRUE);\n");

  return 0;
}

#if 0
/* -1 error, 0 ok */
static int generate_signals(gtk_widget gw)
{
  return 0;
}
#endif

widget_driver resizer_widget_driver = {
  .name = "resizer",
  .first_pass_translation = 0,
  .second_pass_translation = 0,
  .populate_properties = populate_properties,
  .generate_struct = generate_struct,
  .generate_signal_handlers = 0,
  .generate_variable_declaration = generate_variable_declaration,
  .generate_variable_instanciation = generate_variable_instanciation,
  .generate_pack = generate_pack,
  .generate_post_pack = 0,
  .generate_signals = 0
};
