/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://www.nongnu.org/gtkcooker
 * Public domain.
 */

#include <string.h>

#include "widget.h"
#include "generate.h"
#include "files.h"
#include "widget.h"
#include "code.h"
#include "globals.h"

extern widget_driver label_widget_driver;
extern widget_driver button_widget_driver;

#if 0
/* -1 error, 0 ok */
static int first_pass_translation(widget w, widget_element e)
{
  return 0;
}
#endif

#if 0
/* -1 error, 0 ok */
static int second_pass_translation(widget w, widget_element e)
{
  return 0;
}
#endif

/* -1 error, 0 ok */
static int populate_properties(gtk_widget gw)
{
  int has_to_populate = 0;
  gtk_widget sw = SCROLL_CHILD(gw);
  widget_driver *sd = WIDGET_DRIVER(sw);

  POPULATE_PROPERTIES

  if (has_to_populate)
    if (sd->populate_properties)
      if (sd->populate_properties(sw) == -1) return -1;

  return 0;
}

/* -1 error, 0 ok */
static int generate_struct(gtk_widget gw)
{
  if (!IS_GLOBAL(gw)) return 0;

  if (hide_gtk)
    PUT_H("  /* GtkWidget* */ void *");
  else
    PUT_H("  GtkWidget *");
  PUT_H(get_identifier(WIDGET_NAME(gw)));
  PUT_H(";\n");

  return 0;
}

#if 0
/* -1 error, 0 ok */
static int generate_signal_handlers(widget w, gtk_widget gw)
{
  return 0;
}
#endif

/* -1 error, 0 ok */
static int generate_variable_declaration(gtk_widget gw)
{
  if (IS_GLOBAL(gw)) return 0;

  PUT_C("  GtkWidget *");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C(";\n");

  return 0;
}

/* -1 error, 0 ok */
static int generate_variable_instanciation(gtk_widget gw)
{
  if (WIDGET_HSCROLL_TYPE(gw) == -1) WIDGET_HSCROLL_TYPE(gw) = SCROLL_ALWAYS;
  if (WIDGET_VSCROLL_TYPE(gw) == -1) WIDGET_VSCROLL_TYPE(gw) = SCROLL_ALWAYS;

  if (WIDGET_HSCROLL_POSITION(gw) == -1)
    WIDGET_HSCROLL_POSITION(gw) = SCROLL_BOTTOM;
  if (WIDGET_VSCROLL_POSITION(gw) == -1)
    WIDGET_VSCROLL_POSITION(gw) = SCROLL_RIGHT;

  PUT_C("  ");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C(" = gtk_scrolled_window_new(0, 0);\n");

  PUT_C("  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("),\n");
  PUT_C("      GTK_SHADOW_NONE);\n");
  PUT_C("  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("),\n");
  PUT_C("      ");
  switch (WIDGET_HSCROLL_TYPE(gw)) {
    case SCROLL_ALWAYS:
      PUT_C("GTK_POLICY_ALWAYS");
      break;
    case SCROLL_AUTOMATIC:
      PUT_C("GTK_POLICY_AUTOMATIC");
      break;
    case SCROLL_NEVER:
      PUT_C("GTK_POLICY_NEVER");
      break;
  }
  PUT_C(", ");
  switch (WIDGET_VSCROLL_TYPE(gw)) {
    case SCROLL_ALWAYS:
      PUT_C("GTK_POLICY_ALWAYS");
      break;
    case SCROLL_AUTOMATIC:
      PUT_C("GTK_POLICY_AUTOMATIC");
      break;
    case SCROLL_NEVER:
      PUT_C("GTK_POLICY_NEVER");
      break;
  }
  PUT_C(");\n");
  PUT_C("  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("),\n");
  PUT_C("      ");
  /* a bit barbarian, no? */
  switch(WIDGET_VSCROLL_POSITION(gw) + (WIDGET_HSCROLL_POSITION(gw)-2)*2) {
    /* gtkcooker specifies the position of the scrollbars, gtk the position
     * of the child widget
     */
    case 0: /* LEFT TOP */
      PUT_C("GTK_CORNER_BOTTOM_RIGHT");
      break;
    case 1: /* RIGHT TOP */
      PUT_C("GTK_CORNER_BOTTOM_LEFT");
      break;
    case 2: /* LEFT BOTTOM */
      PUT_C("GTK_CORNER_TOP_RIGHT");
      break;
    case 3: /* RIGHT BOTTOM */
      PUT_C("GTK_CORNER_TOP_LEFT");
      break;
  }
  PUT_C(");\n");

#if 0
  GENERATE_WIDTH_AND_HEIGHT
  GENERATE_BORDER_WIDTH
#endif

  GENERATE_FOREGROUND_AND_BACKGROUND

  return 0;
}

/* -1 error, 0 ok */
static int generate_pack(gtk_widget gw)
{
  gtk_widget sw = SCROLL_CHILD(gw);
//  if (GET_TYPE(WIDGET_TYPE(sw)) == TEXT && TEXT_TYPE(sw) == TEXT_MULTILINES) {
    PUT_C("  gtk_container_add(GTK_CONTAINER(");
    if (IS_GLOBAL(gw)) PUT_C("this->");
    PUT_C(get_identifier(WIDGET_NAME(gw)));
    PUT_C("), ");
    if (hide_gtk)
      PUT_C("(GtkWidget *)");
    if (IS_GLOBAL(sw)) PUT_C("this->");
    PUT_C(get_identifier(WIDGET_NAME(sw)));
    PUT_C(");\n");
#if 0
  } else {
    PUT_C("  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(");
    if (IS_GLOBAL(gw)) PUT_C("this->");
    PUT_C(get_identifier(WIDGET_NAME(gw)));
    PUT_C("),\n      ");
    if (IS_GLOBAL(sw)) PUT_C("this->");
    PUT_C(get_identifier(WIDGET_NAME(sw)));
    PUT_C(");\n");
  }
#endif

  return 0;
}

#if 0
/* -1 error, 0 ok */
static int generate_post_pack(gtk_widget gw)
{
  return 0;
}
#endif

#if 0
/* -1 error, 0 ok */
static int generate_signals(gtk_widget gw)
{
  return 0;
}
#endif

widget_driver scroll_widget_driver = {
  .name = "scroll",
  .first_pass_translation = 0,
  .second_pass_translation = 0,
  .populate_properties = populate_properties,
  .generate_struct = generate_struct,
  .generate_signal_handlers = 0,
  .generate_variable_declaration = generate_variable_declaration,
  .generate_variable_instanciation = generate_variable_instanciation,
  .generate_pack = generate_pack,
  .generate_post_pack = 0,
  .generate_signals = 0
};
