/*
 * gtkcooker: an abstraction layer on top of gtk
 * http://www.nongnu.org/gtkcooker
 * Public domain.
 */

#include <string.h>

#include "widget.h"
#include "generate.h"
#include "files.h"
#include "widget.h"
#include "code.h"
#include "globals.h"

extern widget_driver label_widget_driver;
extern widget_driver button_widget_driver;

#if 0
/* -1 error, 0 ok */
static int first_pass_translation(widget w, widget_element e)
{
  return 0;
}
#endif

#if 0
/* -1 error, 0 ok */
static int second_pass_translation(widget w, widget_element e)
{
  return 0;
}
#endif

/* -1 error, 0 ok */
static int populate_properties(gtk_widget gw)
{
  int has_to_populate = 0;
  gtk_widget sw = VIEWPORT_CHILD(gw);
  widget_driver *sd = WIDGET_DRIVER(sw);

  POPULATE_PROPERTIES

  if (has_to_populate)
    if (sd->populate_properties)
      if (sd->populate_properties(sw) == -1) return -1;

  return 0;
}

/* -1 error, 0 ok */
static int generate_struct(gtk_widget gw)
{
  if (!IS_GLOBAL(gw)) return 0;

  if (hide_gtk)
    PUT_H("  /* GtkWidget* */ void *");
  else
    PUT_H("  GtkWidget *");
  PUT_H(get_identifier(WIDGET_NAME(gw)));
  PUT_H(";\n");

  return 0;
}

#if 0
/* -1 error, 0 ok */
static int generate_signal_handlers(widget w, gtk_widget gw)
{
  return 0;
}
#endif

/* -1 error, 0 ok */
static int generate_variable_declaration(gtk_widget gw)
{
  if (IS_GLOBAL(gw)) return 0;

  PUT_C("  GtkWidget *");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C(";\n");

  return 0;
}

/* -1 error, 0 ok */
static int generate_variable_instanciation(gtk_widget gw)
{
  PUT_C("  ");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C(" = gtk_viewport_new(0, 0);\n");

  PUT_C("  gtk_viewport_set_shadow_type(GTK_VIEWPORT(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("),\n");
  PUT_C("      GTK_SHADOW_NONE);\n");

#if 0
  GENERATE_WIDTH_AND_HEIGHT
  GENERATE_BORDER_WIDTH
#endif

  GENERATE_FOREGROUND_AND_BACKGROUND

  return 0;
}

/* -1 error, 0 ok */
static int generate_pack(gtk_widget gw)
{
  gtk_widget sw = VIEWPORT_CHILD(gw);
  PUT_C("  gtk_container_add(GTK_CONTAINER(");
  if (IS_GLOBAL(gw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(gw)));
  PUT_C("), ");
  if (hide_gtk)
    PUT_C("(GtkWidget *)");
  if (IS_GLOBAL(sw)) PUT_C("this->");
  PUT_C(get_identifier(WIDGET_NAME(sw)));
  PUT_C(");\n");

  return 0;
}

#if 0
/* -1 error, 0 ok */
static int generate_post_pack(gtk_widget gw)
{
  return 0;
}
#endif

#if 0
/* -1 error, 0 ok */
static int generate_signals(gtk_widget gw)
{
  return 0;
}
#endif

widget_driver viewport_widget_driver = {
  .name = "viewport",
  .first_pass_translation = 0,
  .second_pass_translation = 0,
  .populate_properties = populate_properties,
  .generate_struct = generate_struct,
  .generate_signal_handlers = 0,
  .generate_variable_declaration = generate_variable_declaration,
  .generate_variable_instanciation = generate_variable_instanciation,
  .generate_pack = generate_pack,
  .generate_post_pack = 0,
  .generate_signals = 0
};
