#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 8 "grammar.y"

/* C declarations */

/* the mode: the lexer should behave in various ways, depending
 * on this variable
 * possible values:
 * LEXER_NORMAL		parse a word or a symbol, one at a time
 * LEXER_C_CODE		parse some code between '{' and '}'
 * LEXER_F_ARGS		parse a function arguments' list (something like
                        "int x, char* y") or a function call's parameters
			(like "x, y, "a", 'b', 2")
 * LEXER_C_STRING	parse a C string (the ending '"' won't be eaten)
 * LEXER_INCLUDE_STUFF	parse between #include and End Of Line
 * LEXER_INIT_VARS	parse a C block, but omit the '{' and '}'
 *			(the C block shall contain only variables'
 *			declarations)
 * LEXER_C_CODE_NO_BRACKET same meaning as LEXER_INIT_VARS
 */
#define LEXER_NORMAL			0
#define LEXER_C_CODE			1
#define LEXER_F_ARGS			2
#define LEXER_C_STRING			3
#define LEXER_INCLUDE_STUFF		4
#define LEXER_INIT_VARS			5
#define LEXER_C_CODE_NO_BRACKET		6

#include <string.h>

#include "widget.h"
#include "string.h"
#include "identifier.h"
#include "list.h"
#include "c_fun_args.h"
#include "files.h"
#include "keywords.h"

static int lexer_mode = LEXER_NORMAL;
static int line = 0;
static int init_first_shot;

void yyerror(char *);
static char *buffer;
static int buffer_size;
static int buffer_maxsize;
static int put(int);
void end_parse(void);
static int yylex(void);

static keyword buffer_keyword;

widget current_widget;

extern list cinclude;
extern list hinclude;
extern list ccode;
extern list hcode;

#line 74 "grammar.y"
typedef union {
  widget widget;
  int integer;
  property_value property_value;
  widget_argument_value widget_argument_value;
  float f;
} YYSTYPE;
#line 72 "y.tab.c"
#define WIDGET 257
#define IDENTIFIER 258
#define FLOAT 259
#define INTEGER 260
#define C_STRING 261
#define C_CODE 262
#define F_ARGS 263
#define INCLUDE_STUFF 264
#define POST_INIT 265
#define INIT 266
#define INCLUDE 267
#define CINCLUDE 268
#define HINCLUDE 269
#define INIT_VARS 270
#define CCODE 271
#define HCODE 272
#define KEYWORD 273
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   25,   25,   27,   27,   27,   26,   26,   26,   30,
   31,   29,   32,   33,   29,   28,   34,   34,   36,   36,
   37,   38,    1,   35,   39,   43,   44,   39,   40,   40,
   42,   42,   41,   41,   45,   45,   45,   46,   46,   47,
   47,   48,   48,   23,   23,   24,   24,    6,    6,    4,
    4,    4,    3,    5,    5,    2,    2,   22,   22,   22,
   22,   20,   20,   21,   21,   21,   21,   21,   21,    7,
    8,   10,   10,   11,    9,   49,   50,   12,   13,   14,
   51,   15,   52,   53,   16,   54,   17,   18,   19,
};
short yylen[] = {                                         2,
    2,    0,    3,    2,    2,    2,    0,    2,    2,    0,
    0,    6,    0,    0,    6,    4,    2,    2,    1,    1,
    4,    0,    2,    4,    0,    0,    0,    5,    0,    2,
    0,    2,    0,    2,    1,    1,    1,    3,    6,    6,
    9,    5,    4,    0,    3,    3,    5,    1,    3,    1,
    1,    1,    1,    1,    1,    1,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    0,    5,    4,    1,
    0,    2,    0,    0,    5,    0,    2,    1,    1,
};
short yydefred[] = {                                      2,
    0,    0,    0,    0,   86,   86,   86,    3,    0,    0,
    0,    8,    9,    0,    4,    0,    5,    6,   88,   89,
    0,   20,   17,   18,   10,   13,    0,   87,   22,    0,
    0,   26,    0,    0,    0,    0,   11,   14,    0,   16,
    0,   33,   21,   23,    0,    0,   27,   83,   30,    0,
   12,   15,    0,    0,    0,    0,    0,   54,    0,   24,
   34,   35,   36,   37,   28,   84,   32,    0,   55,    0,
    0,    0,    0,    0,    0,   38,   63,   62,    0,   74,
    0,    0,    0,   48,    0,   52,   50,   51,   85,   75,
   76,    0,   58,   59,   73,   60,   72,   61,   71,   70,
   56,    0,    0,    0,    0,    0,   43,    0,    0,    0,
    0,    0,   64,   65,   66,   67,   68,    0,   69,    0,
    0,    0,   45,    0,   42,   49,   77,   39,   57,   81,
   40,    0,   46,    0,    0,    0,    0,    0,    0,   78,
   79,   82,    0,   47,   41,
};
short yydgoto[] = {                                       1,
   35,   92,   56,   84,   57,   85,  113,  114,   95,  115,
   97,  116,  117,  118,  136,  119,   15,   99,  100,   79,
  120,  101,   83,  105,    2,    4,    8,   12,   13,   30,
   45,   31,   46,   14,   33,   23,   24,   36,   34,   42,
   50,   60,   39,   53,   61,   62,   63,   64,  109,  135,
  137,   54,   74,   16,
};
short yysindex[] = {                                      0,
    0,  -10, -184, -230,    0,    0,    0,    0, -243,  -89,
  -79,    0,    0,  -77,    0, -207,    0,    0,    0,    0,
   30,    0,    0,    0,    0,    0,  -50,    0,    0, -188,
 -185,    0,  -47, -180,   46, -175,    0,    0, -179,    0,
  -30,    0,    0,    0,  -35,  -29,    0,    0,    0, -206,
    0,    0,  -27, -170,  -30, -243,  -33,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -28,    0, -243,
 -166,   55, -198,  -26,  -31,    0,    0,    0,   36,    0,
    7, -172, -198,    0,  -16,    0,    0,    0,    0,    0,
    0,   -9,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -34,   56,   45,   -8,   20,    0, -198, -157,   49,
  -31,    0,    0,    0,    0,    0,    0,   65,    0,   50,
 -243,  -34,    0, -172,    0,    0,    0,    0,    0,    0,
    0,   51,    0,   52,   77,   72, -149,  -34,  -34,    0,
    0,    0,   57,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    1,    0,  115,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   -6,    0,    0,    0,    0,    0, -121,    0,    0,    0,
    0,    0,    0, -119,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -7,
    0,    0,    0,    0,    0,    0,    0,    0,  -41,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -197,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -22,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,   13,   67,   41,  -66,  -64,    0,  -58,
  -57,  -55,    0,    0,    0,  -17,   59,   -1,   -2,    4,
  -99,   15,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 273
short yytable[] = {                                      91,
    7,   55,   91,   25,   55,   29,   22,   21,   93,   73,
   94,   75,   70,   81,   19,   86,   96,   80,   88,   98,
   55,   88,  133,   49,    3,   86,    9,  108,   72,   20,
   76,  110,  123,   25,  111,  124,   88,   67,  143,  144,
   10,   11,  107,   26,   93,   27,   94,   59,   58,   55,
   86,   19,   96,   69,   58,   98,   28,   71,   55,   19,
   44,   80,   44,  108,   17,   18,   20,   78,   77,   29,
   88,   87,   32,   37,   20,   44,   38,   40,  125,  104,
   88,   87,    5,    6,    7,   41,   43,   44,   48,   51,
   47,   66,   48,   80,   82,   52,  102,   65,   89,  103,
   20,  121,  122,  127,  130,   88,   87,  128,  131,  139,
  140,  138,  141,  142,    1,  145,   19,   31,   78,   77,
  126,  134,   68,  106,  132,  129,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   25,    0,   29,    0,
    0,    0,    0,   25,   25,   29,    0,    0,    0,    0,
    0,   25,    0,   29,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   53,    0,    0,    0,
    0,    0,    0,  112,   90,   80,   19,   90,   80,    0,
    0,   53,    0,    0,    0,    0,    0,    0,   20,    0,
    0,   20,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    7,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    7,    7,
};
short yycheck[] = {                                      34,
    0,   43,   34,  125,   46,  125,    9,    9,   75,   43,
   75,   40,   46,   71,  258,   73,   75,   40,   41,   75,
   62,   44,  122,   41,   35,   83,  257,   44,   62,  273,
   59,   41,   41,  123,   44,   44,   59,   55,  138,  139,
  271,  272,   59,  123,  111,  123,  111,   50,   50,   91,
  108,  258,  111,   56,   56,  111,  264,   91,  265,  258,
  258,  260,  260,   44,    6,    7,  273,   70,   70,   40,
   73,   73,  123,  262,  273,  273,  262,  125,   59,   82,
   83,   83,  267,  268,  269,  266,   41,  263,  123,  125,
  270,  262,  123,  260,   40,  125,   61,  125,  125,   93,
  273,   46,   58,  261,   40,  108,  108,   59,   59,   58,
   34,   61,   41,  263,    0,   59,  123,  125,  121,  121,
  108,  124,   56,   83,  121,  111,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  258,   -1,  258,   -1,
   -1,   -1,   -1,  265,  266,  265,   -1,   -1,   -1,   -1,
   -1,  273,   -1,  273,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  258,   -1,   -1,   -1,
   -1,   -1,   -1,  258,  259,  260,  258,  259,  260,   -1,
   -1,  273,   -1,   -1,   -1,   -1,   -1,   -1,  273,   -1,
   -1,  273,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  271,  272,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 273
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'\"'","'#'",0,0,0,0,"'('","')'",0,"'+'","','",0,"'.'",0,0,0,0,0,0,0,0,0,0,0,
"':'","';'",0,"'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",
0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"WIDGET","IDENTIFIER","FLOAT","INTEGER",
"C_STRING","C_CODE","F_ARGS","INCLUDE_STUFF","POST_INIT","INIT","INCLUDE",
"CINCLUDE","HINCLUDE","INIT_VARS","CCODE","HCODE","KEYWORD",
};
char *yyrule[] = {
"$accept : file",
"file : includes widget_list",
"includes :",
"includes : includes '#' include",
"include : INCLUDE include_string",
"include : CINCLUDE include_string",
"include : HINCLUDE include_string",
"widget_list :",
"widget_list : widget_list widget",
"widget_list : widget_list code",
"$$1 :",
"$$2 :",
"code : CCODE '{' $$1 C_CODE $$2 '}'",
"$$3 :",
"$$4 :",
"code : HCODE '{' $$3 C_CODE $$4 '}'",
"widget : widget_declaration '{' widget_body '}'",
"widget_declaration : WIDGET widget_declaration_simple",
"widget_declaration : WIDGET widget_declaration_complex",
"widget_declaration_simple : identifier",
"widget_declaration_simple : keyword",
"widget_declaration_complex : identifier '(' widget_declaration_arguments ')'",
"$$5 :",
"widget_declaration_arguments : $$5 F_ARGS",
"widget_body : init_vars init_code widget_body_next post_init_code",
"init_vars :",
"$$6 :",
"$$7 :",
"init_vars : '{' $$6 INIT_VARS $$7 '}'",
"init_code :",
"init_code : INIT c_code_value",
"post_init_code :",
"post_init_code : POST_INIT c_code_value",
"widget_body_next :",
"widget_body_next : widget_body_next widget_unit_declaration",
"widget_unit_declaration : widget_element_declaration",
"widget_unit_declaration : widget_property_setting",
"widget_unit_declaration : widget_packing",
"widget_element_declaration : widget_type widget_name ';'",
"widget_element_declaration : widget_type widget_name '(' widget_arguments ')' ';'",
"widget_property_setting : widget_name '.' property_name '=' property_value ';'",
"widget_property_setting : widget_name '[' integer_value ']' '.' property_name '=' property_value ';'",
"widget_packing : widget_name '>' widget_packing_attributes widget_pack_name_list ';'",
"widget_packing : widget_name '+' widget_pack_name_list ';'",
"widget_packing_attributes :",
"widget_packing_attributes : '(' widget_packing_attributes_list ')'",
"widget_packing_attributes_list : keyword ':' property_value",
"widget_packing_attributes_list : widget_packing_attributes_list ',' keyword ':' property_value",
"widget_pack_name_list : widget_pack_name",
"widget_pack_name_list : widget_pack_name_list ',' widget_pack_name",
"widget_pack_name : identifier",
"widget_pack_name : keyword",
"widget_pack_name : integer_value",
"widget_type : keyword",
"widget_name : identifier",
"widget_name : keyword",
"widget_arguments : widget_argument",
"widget_arguments : widget_arguments ',' widget_argument",
"widget_argument : keyword_value",
"widget_argument : identifier_value",
"widget_argument : float_or_integer_value",
"widget_argument : string_value",
"property_name : keyword",
"property_name : identifier",
"property_value : keyword_value",
"property_value : identifier_value",
"property_value : float_or_integer_value",
"property_value : string_value",
"property_value : function_call_value",
"property_value : c_code_value",
"keyword_value : keyword",
"identifier_value : identifier",
"float_or_integer_value : integer_value",
"float_or_integer_value : float_value",
"integer_value : INTEGER",
"float_value : FLOAT",
"$$8 :",
"$$9 :",
"string_value : '\"' $$8 C_STRING $$9 '\"'",
"function_call_value : function_name '(' function_arguments ')'",
"function_name : IDENTIFIER",
"$$10 :",
"function_arguments : $$10 F_ARGS",
"$$11 :",
"$$12 :",
"c_code_value : '{' $$11 C_CODE $$12 '}'",
"$$13 :",
"include_string : $$13 INCLUDE_STUFF",
"identifier : IDENTIFIER",
"keyword : KEYWORD",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 715 "grammar.y"

/* C code */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

/* return 0 if ok, -1 if error */
int put(int c)
{
  if (buffer_size == buffer_maxsize) {
    char *nb;
    if (!buffer_size)
      nb = malloc(256);
    else
      nb = realloc(buffer, buffer_maxsize + 256);
    if (!nb) {
      fprintf(stderr, "out of memory\n");
      return -1;
    }
    buffer = nb;
    buffer_maxsize += 256;
  }
  buffer[buffer_size] = c;
  buffer_size++;
  return 0;
}

int get_byte(void)
{
  int c = get();
  if (c == EOF) return -1;
  if (c == '\n') line++;
  return c;
}

void unget_byte(int c)
{
  if (c == '\n') line--;
  unget(c);
}

/* -1 error, 0 no comment, 1 comment removed */
int check_comments(int c, int put_it)
{
  if (c != '/') return 0;
  c = get_byte();

  if (c == '*') {
    if (put_it) if (put('/') == -1 || put('*') == -1) return -1;
    while (1) {
      do {
        c = get_byte();
        if (c == -1) { fprintf(stderr, "bad C comment\n"); return -1; }
        if (put_it) if (put(c) == -1) return -1;
      } while (c != '*');
      c = get_byte();
      if (c == '/') {
        if (put_it) if (put(c) == -1) return -1;
        return 1;
      }
      unget_byte(c);
    }
  }

  if (c == '/') {
    if (put_it) if (put('/') == -1 || put('/') == -1) return -1;
    while (1) {
      c = get_byte();
      if (put_it && c != -1) if (put(c) == -1) return -1;
      if (c == '\n') return 1;
      if (c == -1) { fprintf(stderr, "bad C comment\n"); return -1; }
    }
  }

  unget_byte(c);
  return 0;
}

/* return 0 if ok, -1 if error */
int get_full_string(int sep)
{
  int c = get_byte();
  int last_escape = 0;

  if (c != sep) return -1;

  do {
    if (put(c) == -1) return -1;
    if (last_escape) last_escape = 0; else last_escape = (c == '\\');
    c = get_byte();
    if (c == -1) {
      fprintf(stderr, "unterminated string sequence\n");
      return -1;
    }
  } while (c != sep || last_escape);

  if (put(sep) == -1) return -1;

  return 0;
}

static int _get_c_code(int put_it)
{
  int depth = 0;
  if (put_it) if (put('{') == -1) return -1;
  while (1) {
    int c = get_byte();
    int comment;

    if (c == -1) {
      fprintf(stderr,
              put_it ? "bad C code\n" : "bad init variables' block\n");
      return -1;
    }

    comment = check_comments(c, 1);
    if (comment == -1) return -1;
    if (comment == 1) continue;

    if (c == '}' && depth == 0) {
      unget_byte(c);
      if (put_it) if (put('}') == -1) return -1;
      if (put(0) == -1) return -1;
      if (put_it) return C_CODE;
      return INIT_VARS;
    }

    if (put(c) == -1) return -1;

    if (c == '{') depth++;
    if (c == '}') depth--;

    if (c == '"' || c == '\'') {
      buffer_size--;
      unget_byte(c);
      if (get_full_string(c) == -1)
        return -1;
    }
  }
}

int get_c_code(void)
{
  return _get_c_code(1);
}

int get_init_vars(void)
{
  return _get_c_code(0);
}

int get_c_code_no_bracket(void)
{
  /* let's use _get_c_code(0), but change its return value */
  int r = _get_c_code(0);
  if (r != INIT_VARS) return r;
  return C_CODE;
}

int get_c_string(void)
{
  int c = get_byte();
  int last_escape = 0;

  while (c != '"' || last_escape) {
    if (put(c) == -1) return -1;
    if (last_escape) last_escape = 0; else last_escape = (c == '\\');
    c = get_byte();
    if (c == -1) {
      fprintf(stderr, "bad C string\n");
      return -1;
    }
  }

  if (put(0) == -1) return -1;

  unget_byte('"');

  return C_STRING;
}

int get_include_stuff(void)
{
  while (1) {
    int c = get_byte();
    if (c == -1 || c == '\n') {
      if (put(0) == -1) return -1;
      break;
    }
    if (put(c) == -1) return -1;
  }

  return INCLUDE_STUFF;
}

int get_f_args(void)
{
  int c = get_byte();
  int depth = 0;

  while (c != ')' || depth) {
    int comment = check_comments(c, 0);
    if (comment == -1) return -1;

    if (!comment) if (put(c) == -1) return -1;
    if (c == '(') depth++;
    if (c == ')') depth--;
    if (c == '"' || c == '\'') {
      buffer_size--;
      unget_byte(c);
      if (get_full_string(c) == -1)
        return -1;
    }
    c = get_byte();
    if (c == -1) {
      fprintf(stderr, "bad function arguments\n");
      return -1;
    }
  }

  if (put(0) == -1) return -1;

  unget_byte(')');

  return F_ARGS;
}

int yylex(void)
{
  int c;
  int comment;
  keyword k;

lex_more:
  buffer_size = 0;

  if (lexer_mode == LEXER_C_CODE)
    return get_c_code();

  if (lexer_mode == LEXER_INIT_VARS)
    return get_init_vars();

  if (lexer_mode == LEXER_C_CODE_NO_BRACKET)
    return get_c_code_no_bracket();

  if (lexer_mode == LEXER_C_STRING)
    return get_c_string();

  if (lexer_mode == LEXER_F_ARGS)
    return get_f_args();

  if (lexer_mode == LEXER_INCLUDE_STUFF)
    return get_include_stuff();

  /* let's remove spaces */
  while (1) {
    c = get_byte();
    if (c == -1) return -1;
    if (!isspace(c))
      break;
  }

  /* keyword or identifier */
  if ((c >= 'a' && c <= 'z') ||
      (c >= 'A' && c <= 'Z') ||
      c == '_') {
    while (1) {
      if (put(c) == -1) return -1;
      c = get_byte();
      if ((c >= 'a' && c <= 'z') ||
          (c >= 'A' && c <= 'Z') ||
          (c >= '0' && c <= '9') ||
          c == '_')
        continue;
      unget_byte(c);
      if (put(0) == -1) return -1;
      switch ((k=lookup(buffer, buffer_size-1))) {
        case NULL_KEYWORD:
          return IDENTIFIER;
        case KEYWORD_WIDGET:
          return WIDGET;
        case KEYWORD_INCLUDE:
          return INCLUDE;
        case KEYWORD_CINCLUDE:
          return CINCLUDE;
        case KEYWORD_HINCLUDE:
          return HINCLUDE;
        case KEYWORD_INIT:
          if (init_first_shot == 0)
            return INIT;
          else
            return POST_INIT;
        case KEYWORD_CCODE:
          return CCODE;
        case KEYWORD_HCODE:
          return HCODE;
        default:
          buffer_keyword = k;
          return KEYWORD;
      }
    }
  }

  /* number (integer or float) */
  if (c >= '0' && c <= '9') {
    int dot_done = 0;
    while (1) {
      if (put(c) == -1) return -1;
      c = get_byte();
      if (c >= '0' && c <= '9')
        continue;
      if (c == '.' && !dot_done) {
        dot_done = 1;
        continue;
      }
      unget_byte(c);
      if (put(0) == -1) return -1;
      return dot_done ? FLOAT : INTEGER;
    }
  }

  /* comments */
  comment = check_comments(c, 0);
  if (comment == -1) return -1;
  if (comment == 1) goto lex_more;

  return c;
}

void yyerror(char *s)
{
  fprintf(stderr, "%s:%d:%s\n", get_current_file(), line+1, s);
}

void end_parse(void)
{
  if (!buffer_maxsize) return;
  free(buffer);
  buffer_size = buffer_maxsize = 0;
  buffer = 0;
}
#line 720 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 2:
#line 117 "grammar.y"
{}
break;
case 4:
#line 123 "grammar.y"
{
	    if (list_add_int(cinclude, yyvsp[0].integer) == -1) YYERROR;
	    if (list_add_int(hinclude, yyvsp[0].integer) == -1) YYERROR;
	  }
break;
case 5:
#line 128 "grammar.y"
{
	    if (list_add_int(cinclude, yyvsp[0].integer) == -1) YYERROR;
	  }
break;
case 6:
#line 132 "grammar.y"
{
	    if (list_add_int(hinclude, yyvsp[0].integer) == -1) YYERROR;
	  }
break;
case 7:
#line 139 "grammar.y"
{}
break;
case 8:
#line 141 "grammar.y"
{}
break;
case 9:
#line 143 "grammar.y"
{}
break;
case 10:
#line 148 "grammar.y"
{ lexer_mode = LEXER_C_CODE_NO_BRACKET; }
break;
case 11:
#line 150 "grammar.y"
{ lexer_mode = LEXER_NORMAL; }
break;
case 12:
#line 152 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    if (list_add_int(ccode, s) == -1) YYERROR;
	  }
break;
case 13:
#line 158 "grammar.y"
{ lexer_mode = LEXER_C_CODE_NO_BRACKET; }
break;
case 14:
#line 160 "grammar.y"
{ lexer_mode = LEXER_NORMAL; }
break;
case 15:
#line 162 "grammar.y"
{
	    string s = new_string(buffer);
	    if (s == -1) YYERROR;
	    if (list_add_int(hcode, s) == -1) YYERROR;
	  }
break;
case 16:
#line 171 "grammar.y"
{}
break;
case 17:
#line 176 "grammar.y"
{
	    init_first_shot = 0;
	  }
break;
case 18:
#line 180 "grammar.y"
{
	    init_first_shot = 0;
	  }
break;
case 19:
#line 187 "grammar.y"
{
	    current_widget = new_widget(yyvsp[0].integer, -1);
	    if (current_widget == -1) YYERROR;
	  }
break;
case 20:
#line 192 "grammar.y"
{
	    fprintf(stderr, "%s:%d: keyword '%s' used as widget name, error\n",
	            get_current_file(), line+1, get_keyword(yyvsp[0].integer));
	    YYERROR;
	  }
break;
case 21:
#line 201 "grammar.y"
{
	    current_widget = new_widget(yyvsp[-3].integer, yyvsp[-1].integer);
	    if (current_widget == -1) YYERROR;
	  }
break;
case 22:
#line 208 "grammar.y"
{ lexer_mode = LEXER_F_ARGS; }
break;
case 23:
#line 210 "grammar.y"
{
	    list l;
	    lexer_mode = LEXER_NORMAL;
	    l = parse_arguments(buffer);
	    if (l == -1) YYERROR;
	    yyval.integer = l;
	  }
break;
case 24:
#line 220 "grammar.y"
{}
break;
case 25:
#line 225 "grammar.y"
{}
break;
case 26:
#line 227 "grammar.y"
{ lexer_mode = LEXER_INIT_VARS; }
break;
case 27:
#line 229 "grammar.y"
{ lexer_mode = LEXER_NORMAL; }
break;
case 28:
#line 231 "grammar.y"
{
	    if (set_init_vars(current_widget, buffer) == -1) YYERROR;
	  }
break;
case 29:
#line 237 "grammar.y"
{ init_first_shot = 1; }
break;
case 30:
#line 239 "grammar.y"
{
	    if (set_init_code(current_widget, yyvsp[0].integer) == -1) YYERROR;
	    init_first_shot = 1;
	  }
break;
case 31:
#line 247 "grammar.y"
{}
break;
case 32:
#line 249 "grammar.y"
{
	    if (set_post_init_code(current_widget, yyvsp[0].integer) == -1) YYERROR;
	  }
break;
case 33:
#line 256 "grammar.y"
{}
break;
case 34:
#line 258 "grammar.y"
{}
break;
case 35:
#line 263 "grammar.y"
{}
break;
case 36:
#line 265 "grammar.y"
{}
break;
case 37:
#line 267 "grammar.y"
{}
break;
case 38:
#line 272 "grammar.y"
{
	    /* names of elements must be unique */
	    if (widget_find_element(current_widget, yyvsp[-1].integer) != -1) {
	      fprintf(stderr, "element %s declared twice\n",
		      get_identifier(yyvsp[-1].integer));
	      YYERROR;
	    }
	    if (widget_add_element(current_widget, yyvsp[-2].integer, yyvsp[-1].integer, -1) == -1)
	      YYERROR;
	  }
break;
case 39:
#line 283 "grammar.y"
{
	    /* names of elements must be unique */
	    if (widget_find_element(current_widget, yyvsp[-4].integer) != -1) {
	      fprintf(stderr, "element %s declared twice\n",
		      get_identifier(yyvsp[-4].integer));
	      YYERROR;
	    }
	    if (widget_add_element(current_widget, yyvsp[-5].integer, yyvsp[-4].integer, yyvsp[-2].integer) == -1)
	      YYERROR;
	  }
break;
case 40:
#line 297 "grammar.y"
{
	    widget_element e = widget_find_element(current_widget, yyvsp[-5].integer);
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier(yyvsp[-5].integer));
	      YYERROR;
	    }
	    if (set_property(current_widget, e, yyvsp[-3].integer, yyvsp[-1].property_value) == -1) YYERROR;
	  }
break;
case 41:
#line 308 "grammar.y"
{
	    widget_element e = widget_find_element(current_widget, yyvsp[-8].integer);
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier(yyvsp[-8].integer));
	      YYERROR;
	    }
	    if (yyvsp[-6].integer < 0 || yyvsp[-6].integer >= list_size(widget_element_arguments(
                                              current_widget, e)) / 2) {
	      fprintf(stderr,
                      "number %d unallowed in [n] notation of element %s\n",
		      yyvsp[-6].integer, get_identifier(yyvsp[-8].integer));
	      fprintf(stderr, "max value allowed is %d\n",
	        list_size(widget_element_arguments(current_widget, e))/2-1);
	      YYERROR;
	    }
	    if (set_argument_property(current_widget, e, yyvsp[-6].integer, yyvsp[-3].integer, yyvsp[-1].property_value) == -1)
	      YYERROR;
	  }
break;
case 42:
#line 331 "grammar.y"
{
	    int i;
	    int l;
	    widget_element e = widget_find_element(current_widget, yyvsp[-4].integer);
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier(yyvsp[-4].integer));
	      YYERROR;
	    }
	    /* menu may have "0" (represented as -2) as child */
	    l = list_size(yyvsp[-1].integer);
	    if (widget_element_type(current_widget, e) != KEYWORD_MENU) {
	      for (i=0; i<l; i++)
	        if (list_get_int(yyvsp[-1].integer, i) == -2) {
	          fprintf(stderr,
	              "packing 0 not allowed for element %s (type %s)\n",
	              get_identifier(widget_element_name(current_widget, e)),
	              get_keyword(widget_element_type(current_widget, e)));
	          YYERROR;
	        }
	    }
	    if (pack_new_row(current_widget, e, yyvsp[-2].integer) == -1) YYERROR;
	    if (pack_append(current_widget, e, yyvsp[-1].integer) == -1) YYERROR;
	    /* set dad */
	    for (i=0; i<l; i++) {
	      widget_element x = (widget_element)list_get_int(yyvsp[-1].integer, i);
	      if (x == -2 || x == -3 || x == -4) continue;
	      widget_element_set_dad(current_widget, x, e);
	    }
	  }
break;
case 43:
#line 362 "grammar.y"
{
	    int i;
	    int l;
	    widget_element e = widget_find_element(current_widget, yyvsp[-3].integer);
	    if (e == -1) {
	      fprintf(stderr, "element %s not declared\n",
		      get_identifier(yyvsp[-3].integer));
	      YYERROR;
	    }
	    /* menu may have "0" (represented as -2) as child */
	    l = list_size(yyvsp[-1].integer);
	    if (widget_element_type(current_widget, e) != KEYWORD_MENU) {
	      for (i=0; i<l; i++)
	        if (list_get_int(yyvsp[-1].integer, i) == -2) {
	          fprintf(stderr,
	              "packing 0 not allowed for element %s (type %s)\n",
	              get_identifier(widget_element_name(current_widget, e)),
	              get_keyword(widget_element_type(current_widget, e)));
	          YYERROR;
	        }
	    }
	    if (pack_append(current_widget, e, yyvsp[-1].integer) == -1) YYERROR;
	    /* set dad */
	    for (i=0; i<l; i++) {
	      widget_element x = (widget_element)list_get_int(yyvsp[-1].integer, i);
	      if (x == -2 || x == -3 || x == -4) continue;
	      widget_element_set_dad(current_widget, x, e);
	    }
	  }
break;
case 44:
#line 395 "grammar.y"
{
	    yyval.integer = -1;
	  }
break;
case 45:
#line 399 "grammar.y"
{
	    yyval.integer = yyvsp[-1].integer;
	  }
break;
case 46:
#line 406 "grammar.y"
{
	    list l = new_list();
	    if (l == -1) YYERROR;
	    if (list_add_int(l, yyvsp[-2].integer) == -1) YYERROR;
	    if (list_add_int(l, yyvsp[0].property_value.type) == -1) YYERROR;
	    if (yyvsp[0].property_value.type == PV_NUMBER) {
	      if (list_add_float(l, yyvsp[0].property_value.v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int(l, yyvsp[0].property_value.v.value) == -1) YYERROR;
	    }
	    yyval.integer = l;
	  }
break;
case 47:
#line 419 "grammar.y"
{
	    if (list_add_int(yyvsp[-4].integer, yyvsp[-2].integer) == -1) YYERROR;
	    if (list_add_int(yyvsp[-4].integer, yyvsp[0].property_value.type) == -1) YYERROR;
	    if (yyvsp[0].property_value.type == PV_NUMBER) {
	      if (list_add_float(yyvsp[-4].integer, yyvsp[0].property_value.v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int(yyvsp[-4].integer, yyvsp[0].property_value.v.value) == -1) YYERROR;
	    }
	    yyval.integer = yyvsp[-4].integer;
	  }
break;
case 48:
#line 433 "grammar.y"
{
	    list l = new_list();
	    if (l == -1) YYERROR;
	    if (list_add_int(l, yyvsp[0].integer) == -1) YYERROR;
	    yyval.integer = l;
	  }
break;
case 49:
#line 440 "grammar.y"
{
	    if (list_add_int(yyvsp[-2].integer, yyvsp[0].integer) == -1) YYERROR;
	    yyval.integer = yyvsp[-2].integer;
	  }
break;
case 50:
#line 448 "grammar.y"
{
	    widget_element e = widget_find_element(current_widget, yyvsp[0].integer);
	    if (e == -1) {
	      fprintf(stderr, "packing unknown widget %s\n",
	        get_identifier(yyvsp[0].integer));
	      YYERROR;
	    }
	    yyval.integer = e;
	  }
break;
case 51:
#line 458 "grammar.y"
{
	    /* special case of "separator", we return -3 */
	    if (yyvsp[0].integer == KEYWORD_SEPARATOR)
	      yyval.integer = -3;
	    /* special case of "resizer", we return -4 */
	    else if (yyvsp[0].integer == KEYWORD_RESIZER)
	      yyval.integer = -4;
	    else YYERROR;
	  }
break;
case 52:
#line 468 "grammar.y"
{
	    if (yyvsp[0].integer != 0) {
	      fprintf(stderr, "packing a number (%d) is not allowed\n", yyvsp[0].integer);
	      YYERROR;
	    }
	    yyval.integer = -2;
	  }
break;
case 53:
#line 479 "grammar.y"
{ yyval.integer = yyvsp[0].integer; }
break;
case 54:
#line 484 "grammar.y"
{ yyval.integer = yyvsp[0].integer; }
break;
case 55:
#line 486 "grammar.y"
{
	    fprintf(stderr, "%s:%d: keyword '%s' used as widget name, error\n",
	            get_current_file(), line+1, get_keyword(yyvsp[0].integer));
	    YYERROR;
	  }
break;
case 56:
#line 495 "grammar.y"
{
	    int l = new_list();
	    if (l == -1) YYERROR;
	    if (list_add_int(l, yyvsp[0].widget_argument_value.type) == -1) YYERROR;
	    if (yyvsp[0].widget_argument_value.type == WA_NUMBER) {
	      if (list_add_float(l, yyvsp[0].widget_argument_value.v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int(l, yyvsp[0].widget_argument_value.v.value) == -1) YYERROR;
	    }
	    yyval.integer = l;
	  }
break;
case 57:
#line 507 "grammar.y"
{
	    if (list_add_int(yyvsp[-2].integer, yyvsp[0].widget_argument_value.type) == -1) YYERROR;
	    if (yyvsp[0].widget_argument_value.type == WA_NUMBER) {
	      if (list_add_float(yyvsp[-2].integer, yyvsp[0].widget_argument_value.v.d) == -1) YYERROR;
	    } else {
	      if (list_add_int(yyvsp[-2].integer, yyvsp[0].widget_argument_value.v.value) == -1) YYERROR;
	    }
	    yyval.integer = yyvsp[-2].integer;
	  }
break;
case 58:
#line 520 "grammar.y"
{
	    yyval.widget_argument_value.type = WA_KEYWORD;
	    yyval.widget_argument_value.v.value = yyvsp[0].integer;
	  }
break;
case 59:
#line 525 "grammar.y"
{
	    yyval.widget_argument_value.type = WA_IDENTIFIER;
	    yyval.widget_argument_value.v.value = yyvsp[0].integer;
	  }
break;
case 60:
#line 530 "grammar.y"
{
	    yyval.widget_argument_value.type = WA_NUMBER;
	    yyval.widget_argument_value.v.d = yyvsp[0].f;
	  }
break;
case 61:
#line 535 "grammar.y"
{
	    yyval.widget_argument_value.type = WA_STRING;
	    yyval.widget_argument_value.v.value = yyvsp[0].integer;
	  }
break;
case 62:
#line 543 "grammar.y"
{ yyval.integer = yyvsp[0].integer; }
break;
case 63:
#line 545 "grammar.y"
{
	    fprintf(stderr, "%s:%d: property '%s' does not exist, error\n",
	            get_current_file(), line+1, get_identifier(yyvsp[0].integer));
	    YYERROR;
	  }
break;
case 64:
#line 554 "grammar.y"
{
	    yyval.property_value.type = PV_KEYWORD;
	    yyval.property_value.v.value = yyvsp[0].integer;
	  }
break;
case 65:
#line 559 "grammar.y"
{
	    yyval.property_value.type = PV_IDENTIFIER;
	    yyval.property_value.v.value = yyvsp[0].integer;
	  }
break;
case 66:
#line 564 "grammar.y"
{
	    yyval.property_value.type = PV_NUMBER;
	    yyval.property_value.v.d = yyvsp[0].f;
	  }
break;
case 67:
#line 569 "grammar.y"
{
	    yyval.property_value.type = PV_STRING;
	    yyval.property_value.v.value = yyvsp[0].integer;
	  }
break;
case 68:
#line 574 "grammar.y"
{
	    /*if (function_call_to_c_code() == -1) YYERROR;*/
	    yyval.property_value.type = PV_C_CODE;
	    yyval.property_value.v.value = yyvsp[0].integer;
	  }
break;
case 69:
#line 580 "grammar.y"
{
	    yyval.property_value.type = PV_C_CODE;
	    yyval.property_value.v.value = yyvsp[0].integer;
	  }
break;
case 70:
#line 588 "grammar.y"
{ yyval.integer = yyvsp[0].integer; }
break;
case 71:
#line 593 "grammar.y"
{ yyval.integer = yyvsp[0].integer; }
break;
case 72:
#line 598 "grammar.y"
{
	    yyval.f = yyvsp[0].integer;
	  }
break;
case 73:
#line 602 "grammar.y"
{
	    yyval.f = yyvsp[0].f;
	  }
break;
case 74:
#line 609 "grammar.y"
{
	    int x;
	    if (sscanf(buffer, "%d", &x) != 1) {
	      fprintf(stderr, "bad number\n");
	      YYERROR;
	    }
	    yyval.integer = x;
	  }
break;
case 75:
#line 621 "grammar.y"
{
	    float x;
	    if (sscanf(buffer, "%f", &x) != 1) {
	      fprintf(stderr, "bad number\n");
	      YYERROR;
	    }
	    yyval.f = x;
	  }
break;
case 76:
#line 633 "grammar.y"
{ lexer_mode = LEXER_C_STRING; }
break;
case 77:
#line 635 "grammar.y"
{lexer_mode = LEXER_NORMAL; }
break;
case 78:
#line 637 "grammar.y"
{
	    yyval.integer = new_string(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 79:
#line 645 "grammar.y"
{
	    char *s;
	    buffer_size = 0;
	    if (put('{') == -1) YYERROR;
	    s = get_string(yyvsp[-3].integer);
	    while (*s) { if (put(*s) == -1) YYERROR; s++; }
	    if (put('(') == -1) YYERROR;
	    s = get_string(yyvsp[-1].integer);
	    while (*s) { if (put(*s) == -1) YYERROR; s++; }
	    if (put(')') == -1) YYERROR;
	    if (put(';') == -1) YYERROR;
	    if (put('}') == -1) YYERROR;
	    if (put(0) == -1) YYERROR;
	    yyval.integer = new_string(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 80:
#line 665 "grammar.y"
{
	    yyval.integer = new_string(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 81:
#line 672 "grammar.y"
{ lexer_mode = LEXER_F_ARGS; }
break;
case 82:
#line 674 "grammar.y"
{
	    lexer_mode = LEXER_NORMAL;
	    yyval.integer = new_string(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 83:
#line 683 "grammar.y"
{ lexer_mode = LEXER_C_CODE; }
break;
case 84:
#line 685 "grammar.y"
{ lexer_mode = LEXER_NORMAL; }
break;
case 85:
#line 687 "grammar.y"
{
	    yyval.integer = new_string(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 86:
#line 694 "grammar.y"
{ lexer_mode = LEXER_INCLUDE_STUFF; }
break;
case 87:
#line 696 "grammar.y"
{
	    lexer_mode = LEXER_NORMAL;
	    yyval.integer = new_string(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 88:
#line 704 "grammar.y"
{
	    yyval.integer = new_identifier(buffer);
	    if (yyval.integer == -1) YYERROR;
	  }
break;
case 89:
#line 711 "grammar.y"
{
	    yyval.integer = buffer_keyword;
	  }
break;
#line 1517 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
